/*
Expandable Listmenu Script
Based on http://www.bakketun.net/listmenu/

*/

function elementHasClass( element, className ) {
				 if ( ! element.className ) {
				 		return false;
					}
					var re = new RegExp( "(^|\\s+)" + className + "($|\\s+)" );
					return re.exec( element.className );
}

function initMenus() {
				 if ( ! document.getElementsByTagName ) {
				 		return;
					}
					var singleopen, keepopen
					var menus = document.getElementsByTagName( "ul" );
					for ( var i = 0; i < menus.length; i++) {
							if ( elementHasClass( menus[ i ], "treemenu" ) ) {
								 initMenu( menus[ i],
								 					 elementHasClass( menus[ i ], "singleopen" ),
													 elementHasClass( menus[ i ], "keepopen" )
								 );
							}
					}
}

function getChildNodes( element, tag ) {
				 var foundNodes = new Array();
				 var childNodes = element.childNodes;
				 for (var i= 0; i < childNodes.length; i++ ) {
				 		 var node = childNodes[ i ];
						 //FIXME: should only do convert to lowercase when i HTML-mode
						 if ( node.tagName && ( node.tagName.toLowerCase() == tag ) ) {
						 		foundNodes.push( node );
						}
					}
					return foundNodes;
}

function createA(menu) {
				 var a, text;
				 text = menu.firstChild;
				 a = document.createElement("a");
				 a.href = "#";
				 menu.replaceChild(a, text);
				 a.appendChild(text);
				 return a;
}
				 
function initMenu(menu, singleopen, keepopen) {
				 var item, a, open;
				 var items = getChildNodes(menu, "li");
				 open = false;
				 for (var i = 0; i<items.length; i++) {
				 		 item = items[i];
						 a = getChildNodes(item, "a")[0];
						 var submenu = getChildNodes(item, "ul")[0];
						 if (submenu) {
						 		if (!a) {
									 a = createA(item);
								}
								open = initMenu(submenu, singleopen, keepopen) || open;
								a.onclick = function() { return menuonclick(this, singleopen); }
						} else {
								if (a) open = open || (keepopen && a.href == window.location);
						}
						if (items.className == "treenodeopen") setMenu(item, true);
						open = open || item.className == "treenodeshow";
				 }
				 setMenu(menu.parentNode, open);
				 return open;
}

function menuonclick(a, singleopen) {
				 setMenu(a.parentNode, a.className == "treeclosed");
				 var menus = getChildNodes(a.parentNode.parentNode, "li")
				 if (singleopen) {
				 		for (var i = 0; i<menus.length; i++) {
								if (menus[i] != a.parentNode) {
									 setMenu(menus[i], false);
								}
						}
				}
				return false;
}			 

function setMenu(menu, open) {
				 var a = getChildNodes(menu, "a")[0];
				 var ul = getChildNodes(menu, "ul")[0];
				 if (a && ul) {
				 		if (open) {
							 a.className = "treeopen";
							 ul.style.display = "block";
						} else {
							a.className = "treeclosed";
							ul.style.display = "none";
						}
					}
}
				
initMenus();

/*
Expandable Outline

*/

function InitializeGlobalData()
{
	if ('undefined' != typeof(strRtl))
		strIsRtl = strRtl;

	var divs = document.body.getElementsByTagName("DIV");
	var spans = document.body.getElementsByTagName("SPAN");

	var countDiv = 0;
	var countSpan = 0;
	if (typeof(divs) != "undefined" && null != divs)
		countDiv = divs.length;

	if (typeof(spans) != "undefined" && null != spans)
		countSpan = spans.length;

	allDivsInPage = new Array();
	for (i=0; i < countDiv; i++)
		if (typeof(divs[i].id) != "undefined" &&
			null != divs[i].id &&
			divs[i].id.length > 0)
			allDivsInPage[divs[i].id] = divs[i];

	for (i=0; i < countSpan; i++)
		if (typeof(spans[i].id) != "undefined" &&
			null != spans[i].id &&
			spans[i].id.length > 0)
			allDivsInPage[spans[i].id] = spans[i];

	allImagesInPage = document.body.getElementsByTagName("IMG");
}

function ExpandDiv(theDivName)
{
	InitializeGlobalData();

	if (null == theDivName || typeof(theDivName) == "undefined") return; var theDiv = allDivsInPage[theDivName]; if (null == theDiv || typeof(theDiv) == "undefined") return;
	theDiv.style.display = "block";

	var thePic = allImagesInPage[theDivName + "_img"];
	if (null != thePic && typeof(thePic) != "undefined")
		{
		//* thePic.src = "images/bluedrop.gif"; *//
		thePic.src = strBulletDown;
		thePic.alt = strHide;
		}
}

function CollapseDiv(theDivName)
{
	InitializeGlobalData();

	if (null == theDivName || typeof(theDivName) == "undefined") return; var theDiv = allDivsInPage[theDivName]; if (null == theDiv || typeof(theDiv) == "undefined") return;
	theDiv.style.display = "none";

	var thePic = allImagesInPage[theDivName + "_img"];
	if (null != thePic && typeof(thePic) != "undefined")
		{
		//* thePic.src = "images/blueup" + strIsRtl + ".gif"; *//
		thePic.src = strBulletUp;
		thePic.alt = strShow;
		}
}

function ToggleDiv(theDivName)
{
	InitializeGlobalData();

	if (null == theDivName || typeof(theDivName) == "undefined") return; var theDiv = allDivsInPage[theDivName]; if (null == theDiv || typeof(theDiv) == "undefined") return;

	if (theDiv.style.display.toUpperCase() != "BLOCK")
		ExpandDiv(theDivName);
	else
		CollapseDiv(theDivName);
}
